Index: /trunk/src/sys/arch/mips/mips/trap.c
===================================================================
--- /trunk/src/sys/arch/mips/mips/trap.c	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/trap.c	(revision 152)
@@ -1,5 +1,6 @@
-/*	$NetBSD: trap.c,v 1.217.12.26 2010/05/06 05:31:49 matt Exp $	*/
+/*	trap.c,v 1.217.12.35 2011/04/29 08:26:30 matt Exp	*/
 
 /*
+ * Copyright (c) 1988 University of Utah.
  * Copyright (c) 1992, 1993
  *	The Regents of the University of California.  All rights reserved.
@@ -37,60 +38,22 @@
  *	@(#)trap.c	8.5 (Berkeley) 1/11/94
  */
-/*
- * Copyright (c) 1988 University of Utah.
- *
- * This code is derived from software contributed to Berkeley by
- * the Systems Programming Group of the University of Utah Computer
- * Science Department and Ralph Campbell.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- 
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- * 3. All advertising materials mentioning features or use of this software
- *    must display the following acknowledgement:
- *	This product includes software developed by the University of
- *	California, Berkeley and its contributors.
- * 4. Neither the name of the University nor the names of its contributors
- *    may be used to endorse or promote products derived from this software
- *    without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
- * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
- * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
- * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
- * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
- * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
- * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
- * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
- * SUCH DAMAGE.
- *
- * from: Utah Hdr: trap.c 1.32 91/04/06
- *
- *	@(#)trap.c	8.5 (Berkeley) 1/11/94
- */
-
-#include <sys/cdefs.h>			/* RCS ID & Copyright macro defns */
-
-__KERNEL_RCSID(0, "$NetBSD: trap.c,v 1.217.12.26 2010/05/06 05:31:49 matt Exp $");
+
+#include <sys/cdefs.h>
+__KERNEL_RCSID(0, "trap.c,v 1.217.12.35 2011/04/29 08:26:30 matt Exp");
 
 #include "opt_cputype.h"	/* which mips CPU levels do we support? */
 #include "opt_ddb.h"
 #include "opt_kgdb.h"
+#include "opt_multiprocessor.h"
 
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/kernel.h>
+#include <sys/cpu.h>
 #include <sys/proc.h>
+#include <sys/user.h>
 #include <sys/ras.h>
 #include <sys/signalvar.h>
 #include <sys/syscall.h>
-#include <sys/user.h>
 #include <sys/buf.h>
 #include <sys/ktrace.h>
@@ -105,10 +68,10 @@
 #include <mips/mips_opcode.h>
 
-#include <uvm/uvm_extern.h>
-
-#include <machine/cpu.h>
+#include <uvm/uvm.h>
+
 #include <mips/trap.h>
 #include <mips/reg.h>
 #include <mips/regnum.h>			/* symbolic register indices */
+#include <mips/pcb.h>
 #include <machine/pte.h>
 #include <mips/psl.h>
@@ -131,5 +94,5 @@
 //#define TRAP_DEBUG_ALL
 
-const char * const trap_type[] = {
+const char * const trap_names[] = {
 	"external interrupt",
 	"TLB modification",
@@ -166,10 +129,6 @@
 };
 
-void trap(unsigned int, unsigned int, vaddr_t, vaddr_t, struct trapframe *);
+void trap(uint32_t, uint32_t, vaddr_t, vaddr_t, struct trapframe *);
 void ast(void);
-
-vaddr_t MachEmulateBranch(struct trapframe *, vaddr_t, unsigned int, int);	/* XXX */
-void MachEmulateInst(uint32_t, uint32_t, vaddr_t, struct trapframe *);	/* XXX */
-void MachFPTrap(uint32_t, uint32_t, vaddr_t, struct trapframe *);	/* XXX */
 
 /*
@@ -203,5 +162,5 @@
  */
 void
-trap(unsigned int status, unsigned int cause, vaddr_t vaddr, vaddr_t opc,
+trap(uint32_t status, uint32_t cause, vaddr_t vaddr, vaddr_t pc,
     struct trapframe *tf)
 {
@@ -210,7 +169,10 @@
 	struct proc * const p = curproc;
 	struct trapframe * const utf = l->l_md.md_utf;
+	struct pcb * const pcb = lwp_getpcb(l);
 	vm_prot_t ftype;
 	ksiginfo_t ksi;
 	extern void fswintrberr(void);
+	void *onfault;
+	int rv;
 #if 0
 	struct cpu_info *ci;
@@ -263,10 +225,24 @@
 	dopanic:
 		(void)splhigh();
-		printf("pid %d(%s): ", p->p_pid, p->p_comm);
-		printf("trap: %s in %s mode\n",
-			trap_type[TRAPTYPE(cause)],
+
+		/*
+		 * use snprintf to allow a single, idempotent, readable printf
+		 */
+		char strbuf[256], *str = strbuf;
+		int n, sz = sizeof(strbuf);
+
+		n = snprintf(str, sz, "pid %d(%s): ", p->p_pid, p->p_comm);
+		sz -= n; 
+		str += n;
+		n = snprintf(str, sz, "trap: cpu%d, %s in %s mode\n",
+			cpu_number(), trap_names[TRAPTYPE(cause)],
 			USERMODE(status) ? "user" : "kernel");
-		printf("status=0x%x, cause=0x%x, epc=%#" PRIxVADDR
-			", vaddr=%#" PRIxVADDR, status, cause, opc, vaddr);
+		sz -= n; 
+		str += n;
+		n = snprintf(str, sz, "status=0x%x, cause=0x%x, epc=%#"
+			PRIxVADDR ", vaddr=%#" PRIxVADDR "\n",
+			status, cause, pc, vaddr);
+		sz -= n; 
+		str += n;
 #ifdef TSAR
 		if (vcache_ptype) {
@@ -277,12 +253,22 @@
 		if (USERMODE(status)) {
 			KASSERT(tf == utf);
-			printf(" frame=%p usp=%#" PRIxREGISTER
+			n = snprintf(str, sz, "frame=%p usp=%#" PRIxREGISTER
 			    " ra=%#" PRIxREGISTER "\n",
-			   tf, tf->tf_regs[_R_SP], tf->tf_regs[_R_RA]);
+			    tf, tf->tf_regs[_R_SP], tf->tf_regs[_R_RA]);
+			sz -= n; 
+			str += n;
 		} else {
-			printf(" tf=%p ksp=%p ra=%#" PRIxREGISTER "\n",
-			   tf, tf+1, tf->tf_regs[_R_RA]);
-		}
-			
+			n = snprintf(str, sz, "tf=%p ksp=%p ra=%#"
+			    PRIxREGISTER " ppl=%#x\n",
+			    tf, tf+1, tf->tf_regs[_R_RA],
+			    tf->tf_ppl);
+			sz -= n; 
+			str += n;
+		}
+		printf("%s", strbuf);
+
+		if ((TRAPTYPE(cause) == 6) || (TRAPTYPE(cause) == 7))
+			(void)(*mips_locoresw.lsw_bus_error)(cause);
+
 #if defined(DDB)
 		kdb_trap(type, &tf->tf_registers);
@@ -354,6 +340,5 @@
 		}
 		/*FALLTHROUGH*/
-	case T_TLB_MOD+T_USER:
-	    {
+	case T_TLB_MOD+T_USER: {
 		pt_entry_t *pte;
 		uint32_t pt_entry;
@@ -396,5 +381,5 @@
 			userret(l);
 		return; /* GEN */
-	    }
+	}
 	case T_TLB_LD_MISS:
 	case T_TLB_ST_MISS:
@@ -406,9 +391,10 @@
 		 * through the copyin/copyout routines.
 		 */
-		if (l->l_addr->u_pcb.pcb_onfault == NULL)
+		if (pcb->pcb_onfault == NULL) {
 			goto dopanic;
+		}
 		/* check for fuswintr() or suswintr() getting a page fault */
-		if (l->l_addr->u_pcb.pcb_onfault == (void *)fswintrberr) {
-			tf->tf_regs[_R_PC] = (intptr_t)l->l_addr->u_pcb.pcb_onfault;
+		if (pcb->pcb_onfault == (void *)fswintrberr) {
+			tf->tf_regs[_R_PC] = (intptr_t)pcb->pcb_onfault;
 			return; /* KERN */
 		}
@@ -576,14 +562,60 @@
 		}
 #endif /* TSAR */
-	pagefault:
-	    {
-		vaddr_t va;
-		struct vmspace *vm;
-		struct vm_map *map;
-		int rv;
-
-		vm = p->p_vmspace;
-		map = &vm->vm_map;
-		va = trunc_page(vaddr);
+	pagefault: {
+		const vaddr_t va = trunc_page(vaddr);
+		struct vmspace * const vm = p->p_vmspace;
+		struct vm_map * const map = &vm->vm_map;
+#ifdef PMAP_FAULTINFO
+		struct pcb_faultinfo * const pfi = &pcb->pcb_faultinfo;
+#endif
+
+#ifndef TSAR
+		kpreempt_disable();
+#ifdef _LP64
+		/*
+		 * If the pmap has been activated and we allocated the segtab
+		 * for the low 4GB, seg0tab may still be NULL.  We can't
+		 * really fix this in pmap_enter (we can only update the local
+		 * cpu's cpu_info but not other cpu's) so we need to detect
+		 * and fix this here.
+		 */
+		struct cpu_info * const ci = curcpu();
+		if ((va >> XSEGSHIFT) == 0 &&
+		    __predict_false(ci->ci_pmap_seg0tab == NULL
+				&& ci->ci_pmap_segtab->seg_seg[0] != NULL)) {
+			ci->ci_pmap_seg0tab = ci->ci_pmap_segtab->seg_seg[0];
+			kpreempt_enable();
+			if (type & T_USER) {
+				userret(l);
+			}
+			return; /* GEN */
+		}
+#endif
+		KASSERT(va < 0 || curcpu()->ci_pmap_asid_cur != 0);
+		pmap_tlb_asid_check();
+		kpreempt_enable();
+#endif /* !TSAR */
+
+#ifdef PMAP_FAULTINFO
+		if (p->p_pid == pfi->pfi_lastpid && va == pfi->pfi_faultaddr) {
+			if (++pfi->pfi_repeats > 1) {
+				register_t tlb_hi;
+				pt_entry_t *pte = pfi->pfi_faultpte;
+				__asm("dmfc0 %0,$%1" : "=r"(tlb_hi) : "n"(MIPS_COP_0_TLB_HI));
+				printf("trap: fault #%u (%s/%s) for %#"PRIxVADDR" (%#"PRIxVADDR") at pc %#"PRIxVADDR" curpid=%u/%u pte@%p=%#x)\n", pfi->pfi_repeats, trap_names[TRAPTYPE(cause)], trap_names[pfi->pfi_faulttype], va, vaddr, pc, map->pmap->pm_pai[0].pai_asid, (uint8_t)tlb_hi, pte, pte ? pte->pt_entry : 0);
+				if (pfi->pfi_repeats >= 4) {
+					cpu_Debugger();
+				} else {
+					pfi->pfi_faulttype = TRAPTYPE(cause);       
+				}
+			}
+		} else {
+			pfi->pfi_lastpid = p->p_pid;
+			pfi->pfi_faultaddr = va;
+			pfi->pfi_repeats = 0;
+			pfi->pfi_faultpte = NULL;
+			pfi->pfi_faulttype = TRAPTYPE(cause);
+		}
+#endif /* PMAP_FAULTINFO */
 
 		if ((l->l_flag & LW_SA) && (~l->l_pflag & LP_SA_NOBLOCK)) {
@@ -595,13 +627,17 @@
 		printf("uvm_fault(%p)\n", map);
 #endif
+		onfault = pcb->pcb_onfault;
+		pcb->pcb_onfault = NULL;
 		if (p->p_emul->e_fault)
 			rv = (*p->p_emul->e_fault)(p, va, ftype);
 		else
 			rv = uvm_fault(map, va, ftype);
+		pcb->pcb_onfault = onfault;
+
 #ifdef VMFAULT_TRACE
 		printf(
 		    "uvm_fault(%p (pmap %p), %#"PRIxVADDR
 		    " (%"PRIxVADDR"), %d) -> %d at pc %#"PRIxVADDR"\n",
-		    map, vm->vm_map.pmap, va, vaddr, ftype, rv, opc);
+		    map, vm->vm_map.pmap, va, vaddr, ftype, rv, pc);
 #endif
 		/*
@@ -620,4 +656,11 @@
 		l->l_pflag &= ~LP_SA_PAGEFAULT;
 		if (rv == 0) {
+#ifdef PMAP_FAULTINFO
+			if (pfi->pfi_repeats == 0) {
+				pfi->pfi_faultpte =
+				    pmap_pte_lookup(map->pmap, va);
+			}
+			KASSERT(((pt_entry_t *)(pfi->pfi_faultpte))->pt_entry);
+#endif
 			if (type & T_USER) {
 				userret(l);
@@ -646,20 +689,19 @@
 		ksi.ksi_addr = (void *)vaddr;
 		break; /* SIGNAL */
-	    }
-	kernelfault: ;
-	    {
-		vaddr_t va;
-		int rv;
-
-		va = trunc_page(vaddr);
+	}
+	kernelfault: {
+		onfault = pcb->pcb_onfault;
+
 #ifdef TRAP_DEBUG
 		printf("uvm_fault(kernel_map) on %p\n",
 		    l->l_addr->u_pcb.pcb_onfault);
 #endif
-		rv = uvm_fault(kernel_map, va, ftype);
+		pcb->pcb_onfault = NULL;
+		rv = uvm_fault(kernel_map, trunc_page(vaddr), ftype);
+		pcb->pcb_onfault = onfault;
 		if (rv == 0)
 			return; /* KERN */
-		/*FALLTHROUGH*/
-	    }
+		goto copyfault;
+	}
 	case T_ADDR_ERR_LD:	/* misaligned access */
 	case T_ADDR_ERR_ST:	/* misaligned access */
@@ -667,8 +709,12 @@
 	case T_BUS_ERR_LD_ST:	/* BERR asserted to CPU */
 #endif
+		onfault = pcb->pcb_onfault;
+		rv = EFAULT;
 	copyfault:
-		if (l == NULL || l->l_addr->u_pcb.pcb_onfault == NULL)
+		if (onfault == NULL) {
 			goto dopanic;
-		tf->tf_regs[_R_PC] = (intptr_t)l->l_addr->u_pcb.pcb_onfault;
+		}
+		tf->tf_regs[_R_PC] = (intptr_t)onfault;
+		tf->tf_regs[_R_V0] = rv;
 		return; /* KERN */
 
@@ -697,4 +743,5 @@
 		break; /* SIGNAL */
 
+	case T_WATCH:
 	case T_BREAK:
 #if defined(DDB)
@@ -720,5 +767,5 @@
 			if (!kgdb_trap(type, regs))
 				printf("kgdb: ignored %s\n",
-				       trap_type[TRAPTYPE(cause)]);
+				       trap_names[TRAPTYPE(cause)]);
 			else
 				tf->tf_regs[_R_PC] = regs->r_regs[_R_PC];
@@ -729,15 +776,12 @@
 		goto dopanic;
 #endif
-	case T_BREAK+T_USER:
-	    {
-		vaddr_t va;
+	case T_BREAK+T_USER: {
 		uint32_t instr;
-		int rv;
 
 		/* compute address of break instruction */
-		va = (cause & MIPS_CR_BR_DELAY) ? opc + sizeof(int) : opc;
+		vaddr_t va = pc + (cause & MIPS_CR_BR_DELAY ? sizeof(int) : 0);
 
 		/* read break instruction */
-		instr = fuiword((void *)va);
+		instr = ufetch_uint32((void *)va);
 
 		if (l->l_md.md_ss_addr != va || instr != MIPS_BREAK_SSTEP) {
@@ -777,15 +821,15 @@
 		ksi.ksi_code = TRAP_BRKPT;
 		break; /* SIGNAL */
-	    }
+	}
 	case T_RES_INST+T_USER:
 	case T_COP_UNUSABLE+T_USER:
 #if !defined(FPEMUL) && !defined(NOFPU)
 		if ((cause & MIPS_CR_COP_ERR) == 0x10000000) {
-			fpuload_lwp(l);          	/* load FPA */
+			fpu_load();          	/* load FPA */
 			l->l_md.md_flags |= MDP_FPUSED;
 		} else
 #endif
 		{
-			MachEmulateInst(status, cause, opc, utf);
+			mips_emul_inst(status, cause, pc, utf);
 		}
 		userret(l);
@@ -793,7 +837,8 @@
 	case T_FPE+T_USER:
 #if defined(FPEMUL)
-		MachEmulateInst(status, cause, opc, utf);
+		mips_emul_inst(status, cause, pc, utf);
 #elif !defined(NOFPU)
-		MachFPTrap(status, cause, opc, utf);
+		utf->tf_regs[_R_CAUSE] = cause;
+		mips_fpu_trap(pc, utf);
 #endif
 		userret(l);
@@ -803,5 +848,5 @@
 		ksi.ksi_trap = type & ~T_USER;
 		ksi.ksi_signo = SIGFPE;
-		ksi.ksi_addr = (void *)(intptr_t)opc /*utf->tf_regs[_R_PC]*/;
+		ksi.ksi_addr = (void *)(intptr_t)pc /*utf->tf_regs[_R_PC]*/;
 		ksi.ksi_code = FPE_FLTOVF; /* XXX */
 		break; /* SIGNAL */
@@ -810,7 +855,7 @@
 	utf->tf_regs[_R_BADVADDR] = vaddr;
 #if defined(DEBUG)
-	printf("trap: pid %d(%s): sig %d: cause=%#x epc=%#"PRIxREGISTER
+	printf("trap: cpu%d, pid %d(%s): sig %d: cause=%#x epc=%#"PRIxREGISTER
 	    " va=%#"PRIxVADDR"\n",
-	    p->p_pid, p->p_comm, ksi.ksi_signo, cause,
+	    cpu_number(), p->p_pid, p->p_comm, ksi.ksi_signo, cause,
 	    utf->tf_regs[_R_PC], vaddr);
 	printf("registers:\n");
@@ -843,16 +888,19 @@
 {
 	struct lwp * const l = curlwp;
-	struct cpu_info * const ci = l->l_cpu;
 	u_int astpending;
 
 	while ((astpending = l->l_md.md_astpending) != 0) {
-		uvmexp.softs++;
+		//uvmexp.softs++;
 		l->l_md.md_astpending = 0;
 
 #ifdef MULTIPROCESSOR
 #ifndef TSAR
-		if (ci->ci_tlb_info->ti_synci_page_bitmap != 0)
-			pmap_tlb_syncicache_ast(ci);
-		KASSERT(ci->ci_tlb_info->ti_synci_page_bitmap == 0 || l->l_md.md_astpending);
+		{
+			kpreempt_disable();
+			struct cpu_info * const ci = l->l_cpu;
+			if (ci->ci_tlb_info->ti_synci_page_bitmap != 0)
+				pmap_tlb_syncicache_ast(ci);
+			kpreempt_enable();
+		}
 #endif
 #endif
@@ -865,5 +913,5 @@
 		userret(l);
 
-		if (ci->ci_want_resched) {
+		if (l->l_cpu->ci_want_resched) {
 			/*
 			 * We are being preempted.
@@ -894,8 +942,10 @@
 	}
 	pc = (vaddr_t)tf->tf_regs[_R_PC];
-	if (ufetch_uint32((void *)pc) != 0) /* not a NOP instruction */
-		va = MachEmulateBranch(tf, pc, PCB_FSR(&l->l_addr->u_pcb), 1);
-	else
+	if (ufetch_uint32((void *)pc) != 0) { /* not a NOP instruction */
+		struct pcb * const pcb = lwp_getpcb(l);
+		va = mips_emul_branch(tf, pc, PCB_FSR(pcb), true);
+	} else {
 		va = pc + sizeof(int);
+	}
 
 	/*
@@ -909,5 +959,5 @@
 
 	l->l_md.md_ss_addr = va;
-	l->l_md.md_ss_instr = fuiword((void *)va);
+	l->l_md.md_ss_instr = ufetch_uint32((void *)va);
 	rv = ustore_uint32_isync((void *)va, MIPS_BREAK_SSTEP);
 	if (rv < 0) {
@@ -993,11 +1043,4 @@
 extern char mips3_systemcall[];
 #endif
-#ifdef MIPS3_5900
-extern char mips3_5900_kern_gen_exception[];
-extern char mips3_5900_user_gen_exception[];
-extern char mips3_5900_kern_intr[];
-extern char mips3_5900_user_intr[];
-extern char mips3_5900_systemcall[];
-#endif
 #ifdef MIPS32
 extern char mips32_kern_gen_exception[];
@@ -1007,4 +1050,11 @@
 extern char mips32_systemcall[];
 #endif
+#ifdef MIPS32R2
+extern char mips32r2_kern_gen_exception[];
+extern char mips32r2_user_gen_exception[];
+extern char mips32r2_kern_intr[];
+extern char mips32r2_user_intr[];
+extern char mips32r2_systemcall[];
+#endif
 #ifdef MIPS64
 extern char mips64_kern_gen_exception[];
@@ -1013,4 +1063,25 @@
 extern char mips64_user_intr[];
 extern char mips64_systemcall[];
+#endif
+#ifdef MIPS64R2
+extern char mips64r2_kern_gen_exception[];
+extern char mips64r2_user_gen_exception[];
+extern char mips64r2_kern_intr[];
+extern char mips64r2_user_intr[];
+extern char mips64r2_systemcall[];
+#endif
+#ifdef MIPS64_RMIXL
+extern char mips64_rmixl_kern_gen_exception[];
+extern char mips64_rmixl_user_gen_exception[];
+extern char mips64_rmixl_kern_intr[];
+extern char mips64_rmixl_user_intr[];
+extern char mips64_rmixl_systemcall[];
+#endif
+#ifdef MIPS64R2_RMIXL
+extern char mips64r2_rmixl_kern_gen_exception[];
+extern char mips64r2_rmixl_user_gen_exception[];
+extern char mips64r2_rmixl_kern_intr[];
+extern char mips64r2_rmixl_user_intr[];
+extern char mips64r2_rmixl_systemcall[];
 #endif
 
@@ -1046,4 +1117,9 @@
 	unsigned int frames =  0;
 	int foundframesize = 0;
+	mips_reg_t regs[32] = {
+		[_R_ZERO] = 0,
+		[_R_A0] = a0, [_R_A1] = a1, [_R_A2] = a2, [_R_A3] = a3,
+		[_R_RA] = ra,
+	};
 #ifdef DDB
 	db_expr_t diff;
@@ -1055,4 +1131,5 @@
 	stksize = 0;
 	subr = 0;
+	mask = 1;
 	if (frames++ > 100) {
 		(*printfn)("\nstackframe count exceeded\n");
@@ -1062,5 +1139,5 @@
 
 	/* check for bad SP: could foul up next frame */
-	if (sp & 3 || (intptr_t)sp >= 0) {
+	if ((sp & (sizeof(sp)-1)) || (intptr_t)sp >= 0) {
 		(*printfn)("SP 0x%x: not in kernel\n", sp);
 		ra = 0;
@@ -1130,5 +1207,5 @@
 	stksize = 0;
 	more = 3;
-	mask = 0;
+	mask &= 0x40ff0001;	/* if s0-s8 are valid, leave then as valid */
 	foundframesize = 0;
 	for (va = subr; more; va += sizeof(int),
@@ -1147,8 +1224,25 @@
 				break;
 
+			case OP_ADD:
+			case OP_ADDU:
+			case OP_DADD:
+			case OP_DADDU:
+				if (!(mask & (1 << i.RType.rd))
+				    || !(mask & (1 << i.RType.rt)))
+					break;
+				if (i.RType.rd != _R_ZERO)
+					break;
+				mask |= (1 << i.RType.rs);
+				regs[i.RType.rs] = regs[i.RType.rt];
+				if (i.RType.func >= OP_DADD)
+					break;
+				regs[i.RType.rs] = (int32_t)regs[i.RType.rs];
+				break;
+
 			case OP_SYSCALL:
 			case OP_BREAK:
 				more = 1; /* stop now */
-			};
+				break;
+			}
 			break;
 
@@ -1182,33 +1276,25 @@
 
 			/* look for saved registers on the stack */
-			if (i.IType.rs != 29)
+			if (i.IType.rs != _R_SP)
 				break;
-			/* only restore the first one */
-			if (mask & (1 << i.IType.rt))
+			switch (i.IType.rt) {
+			case _R_A0: /* a0 */
+			case _R_A1: /* a1 */
+			case _R_A2: /* a2 */
+			case _R_A3: /* a3 */
+			case _R_S0: /* s0 */
+			case _R_S1: /* s1 */
+			case _R_S2: /* s2 */
+			case _R_S3: /* s3 */
+			case _R_S4: /* s4 */
+			case _R_S5: /* s5 */
+			case _R_S6: /* s6 */
+			case _R_S7: /* s7 */
+			case _R_S8: /* s8 */
+			case _R_RA: /* ra */
+				regs[i.IType.rt] =
+				    kdbrpeek(sp + (int16_t)i.IType.imm, size);
+				mask |= (1 << i.IType.rt);
 				break;
-			mask |= (1 << i.IType.rt);
-			switch (i.IType.rt) {
-			case 4: /* a0 */
-				a0 = kdbrpeek(sp + (short)i.IType.imm, size);
-				break;
-
-			case 5: /* a1 */
-				a1 = kdbrpeek(sp + (short)i.IType.imm, size);
-				break;
-
-			case 6: /* a2 */
-				a2 = kdbrpeek(sp + (short)i.IType.imm, size);
-				break;
-
-			case 7: /* a3 */
-				a3 = kdbrpeek(sp + (short)i.IType.imm, size);
-				break;
-
-			case 30: /* fp */
-				fp = kdbrpeek(sp + (short)i.IType.imm, size);
-				break;
-
-			case 31: /* ra */
-				ra = kdbrpeek(sp + (short)i.IType.imm, size);
 			}
 			break;
@@ -1222,5 +1308,5 @@
 #endif
 			/* look for stack pointer adjustment */
-			if (i.IType.rs != 29 || i.IType.rt != 29)
+			if (i.IType.rs != _R_SP || i.IType.rt != _R_SP)
 				break;
 			/* don't count pops for mcount */
@@ -1229,9 +1315,14 @@
 				foundframesize = 1;
 			}
+			break;
 		}
 	}
 done:
-	(*printfn)("%s+%"PRIxVADDR" (%"PRIxREGISTER",%"PRIxREGISTER",%"PRIxREGISTER",%"PRIxREGISTER") ra %"PRIxVADDR" sz %d\n",
-		fn_name(subr), pc - subr, a0, a1, a2, a3, ra, stksize);
+	if (mask & (1 << _R_RA))
+		ra = regs[_R_RA];
+	(*printfn)("%#"PRIxVADDR": %s+%"PRIxVADDR" (%"PRIxREGISTER",%"PRIxREGISTER",%"PRIxREGISTER",%"PRIxREGISTER") ra %"PRIxVADDR" sz %d\n",
+		sp, fn_name(subr), pc - subr,
+		regs[_R_A0], regs[_R_A1], regs[_R_A2], regs[_R_A3],
+		ra, stksize);
 
 	if (ra) {
@@ -1246,9 +1337,6 @@
 	} else {
 finish:
-		if (curlwp)
-			(*printfn)("User-level: pid %d.%d\n", 
-			    curlwp->l_proc->p_pid, curlwp->l_lid);
-		else
-			(*printfn)("User-level: curlwp NULL\n");
+		(*printfn)("User-level: pid %d.%d\n", 
+		    curlwp->l_proc->p_pid, curlwp->l_lid);
 	}
 }
@@ -1257,9 +1345,5 @@
  * Functions ``special'' enough to print by name
  */
-#ifdef __STDC__
 #define Name(_fn)  { (void*)_fn, # _fn }
-#else
-#define Name(_fn) { _fn, "_fn"}
-#endif
 const static struct { void *addr; const char *name;} names[] = {
 	Name(stacktrace),
@@ -1284,12 +1368,4 @@
 #endif	/* MIPS3 */
 
-#if defined(MIPS3_5900)			/* r5900 family (mips-III CPU) */
-	Name(mips5900_kern_gen_exception),
-	Name(mips5900_user_gen_exception),
-	Name(mips5900_systemcall),
-	Name(mips5900_kern_intr),
-	Name(mips5900_user_intr),
-#endif	/* MIPS3_5900 */
-
 #if defined(MIPS32)			/* MIPS32 family (mips-III CPU) */
 	Name(mips32_kern_gen_exception),
@@ -1300,4 +1376,12 @@
 #endif	/* MIPS32 */
 
+#if defined(MIPS32R2)			/* MIPS32R2 family (mips-III CPU) */
+	Name(mips32r2_kern_gen_exception),
+	Name(mips32r2_user_gen_exception),
+	Name(mips32r2_systemcall),
+	Name(mips32r2_kern_intr),
+	Name(mips32r2_user_intr),
+#endif	/* MIPS32R2 */
+
 #if defined(MIPS64)			/* MIPS64 family (mips-III CPU) */
 	Name(mips64_kern_gen_exception),
@@ -1307,4 +1391,28 @@
 	Name(mips64_user_intr),
 #endif	/* MIPS64 */
+
+#if defined(MIPS64R2)			/* MIPS64R2 family (mips-III CPU) */
+	Name(mips64r2_kern_gen_exception),
+	Name(mips64r2_user_gen_exception),
+	Name(mips64r2_systemcall),
+	Name(mips64r2_kern_intr),
+	Name(mips64r2_user_intr),
+#endif	/* MIPS64R2 */
+
+#if defined(MIPS64_RMIXL)		/* RMI MIPS64 family (mips-III CPU) */
+	Name(mips64_rmixl_kern_gen_exception),
+	Name(mips64_rmixl_user_gen_exception),
+	Name(mips64_rmixl_systemcall),
+	Name(mips64_rmixl_kern_intr),
+	Name(mips64_rmixl_user_intr),
+#endif	/* MIPS64_RMIXL */
+
+#if defined(MIPS64R2_RMIXL)		/* RMI MIPS64R2 family (mips-III CPU) */
+	Name(mips64r2_rmixl_kern_gen_exception),
+	Name(mips64r2_rmixl_user_gen_exception),
+	Name(mips64r2_rmixl_systemcall),
+	Name(mips64r2_rmixl_kern_intr),
+	Name(mips64r2_rmixl_user_intr),
+#endif	/* MIPS64R2_RMIXL */
 
 	Name(cpu_idle),
